com.io7m.jpra.compiler.core.checker

## Interface JPRACheckerCapabilitiesType

- All Known Implementing Classes:
    JPRACheckerStandardCapabilities

      public interface JPRACheckerCapabilitiesType

  The capabilities that the checker is responsible for enforcing.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `com.gs.collections.api.list.ImmutableList<com.io7m.jranges.RangeInclusiveB>` | `getMatrixFloatSizeSupported()`
    `com.gs.collections.api.list.ImmutableList<com.io7m.jranges.RangeInclusiveB>` | `getMatrixIntegerSizeSupported()`
    `com.gs.collections.api.list.ImmutableList<com.io7m.jfunctional.Pair<com.io7m.jranges.RangeInclusiveB,com.io7m.jranges.RangeInclusiveB>>` | `getMatrixSizeElementsSupported()`
    `com.gs.collections.api.list.ImmutableList<com.io7m.jranges.RangeInclusiveB>` | `getPackedIntegerSizeBitsSupported()`
    `com.gs.collections.api.list.ImmutableList<com.io7m.jranges.RangeInclusiveB>` | `getPackedSizeBitsSupported()`
    `com.gs.collections.api.list.ImmutableList<com.io7m.jranges.RangeInclusiveB>` | `getRecordFloatSizeBitsSupported()`
    `com.gs.collections.api.list.ImmutableList<com.io7m.jranges.RangeInclusiveB>` | `getRecordIntegerSizeBitsSupported()`
    `com.gs.collections.api.set.ImmutableSet<String>` | `getStringEncodingsSupported()`
    `com.gs.collections.api.list.ImmutableList<com.io7m.jranges.RangeInclusiveB>` | `getVectorFloatSizeSupported()`
    `com.gs.collections.api.list.ImmutableList<com.io7m.jranges.RangeInclusiveB>` | `getVectorIntegerSizeSupported()`
    `com.gs.collections.api.list.ImmutableList<com.io7m.jranges.RangeInclusiveB>` | `getVectorSizeSupported()`
    `boolean` | `isMatrixFloatSizeSupported(BigInteger size)`
    `boolean` | `isMatrixIntegerSizeSupported(BigInteger size)`
    `boolean` | `isMatrixSizeElementsSupported(BigInteger width, BigInteger height)`
    `boolean` | `isPackedIntegerSizeBitsSupported(BigInteger size)`
    `boolean` | `isPackedSizeBitsSupported(BigInteger size)`
    `boolean` | `isRecordFloatSizeBitsSupported(BigInteger size)`
    `boolean` | `isRecordIntegerSizeBitsSupported(BigInteger size)`
    `boolean` | `isStringEncodingSupported(String encoding)`
    `boolean` | `isVectorFloatSizeSupported(BigInteger size)`
    `boolean` | `isVectorIntegerSizeSupported(BigInteger size)`
    `boolean` | `isVectorSizeElementsSupported(BigInteger size)`

- - ### Method Detail

    - #### getRecordIntegerSizeBitsSupported

          com.gs.collections.api.list.ImmutableList<com.io7m.jranges.RangeInclusiveB> getRecordIntegerSizeBitsSupported()

      Returns:
        The set of supported `integer` sizes in records

    - #### isRecordIntegerSizeBitsSupported

          boolean isRecordIntegerSizeBitsSupported(BigInteger size)

      Parameters:
        `size` - The size in bits
      Returns:
        `true` iff `integer` types of the given size are supported in records

    - #### isRecordFloatSizeBitsSupported

          boolean isRecordFloatSizeBitsSupported(BigInteger size)

      Parameters:
        `size` - The size in bits
      Returns:
        `true` iff `float` types of the given size are supported in records

    - #### isVectorSizeElementsSupported

          boolean isVectorSizeElementsSupported(BigInteger size)

      Parameters:
        `size` - The size in elements
      Returns:
        `true` iff vectors of the given size are supported

    - #### isMatrixSizeElementsSupported

          boolean isMatrixSizeElementsSupported(BigInteger width,
                                                BigInteger height)

      Parameters:
        `width` - The number of matrix columns
        `height` - The number of matrix rows
      Returns:
        `true` iff matrices of the given size are supported in records

    - #### getRecordFloatSizeBitsSupported

          com.gs.collections.api.list.ImmutableList<com.io7m.jranges.RangeInclusiveB> getRecordFloatSizeBitsSupported()

      Returns:
        The set of supported `float` sizes in records

    - #### isStringEncodingSupported

          boolean isStringEncodingSupported(String encoding)

      Parameters:
        `encoding` - The encoding
      Returns:
        `true` iff the given string encoding is supported

    - #### getStringEncodingsSupported

          com.gs.collections.api.set.ImmutableSet<String> getStringEncodingsSupported()

      Returns:
        The set of supported string encodings

    - #### getVectorSizeSupported

          com.gs.collections.api.list.ImmutableList<com.io7m.jranges.RangeInclusiveB> getVectorSizeSupported()

      Returns:
        The set of supported vector sizes

    - #### isVectorIntegerSizeSupported

          boolean isVectorIntegerSizeSupported(BigInteger size)

      Parameters:
        `size` - The size in bits
      Returns:
        `true` iff `integer` types of the given size are supported in vectors

    - #### getVectorIntegerSizeSupported

          com.gs.collections.api.list.ImmutableList<com.io7m.jranges.RangeInclusiveB> getVectorIntegerSizeSupported()

      Returns:
        The set of supported `integer` sizes in vectors

    - #### isVectorFloatSizeSupported

          boolean isVectorFloatSizeSupported(BigInteger size)

      Parameters:
        `size` - The size in bits
      Returns:
        `true` iff `float` types of the given size are supported in vectors

    - #### getVectorFloatSizeSupported

          com.gs.collections.api.list.ImmutableList<com.io7m.jranges.RangeInclusiveB> getVectorFloatSizeSupported()

      Returns:
        The set of supported `float` sizes in vectors

    - #### getMatrixSizeElementsSupported

          com.gs.collections.api.list.ImmutableList<com.io7m.jfunctional.Pair<com.io7m.jranges.RangeInclusiveB,com.io7m.jranges.RangeInclusiveB>> getMatrixSizeElementsSupported()

      Returns:
        The set of supported matrix sizes

    - #### isMatrixIntegerSizeSupported

          boolean isMatrixIntegerSizeSupported(BigInteger size)

      Parameters:
        `size` - The size in bits
      Returns:
        `true` iff `integer` types of the given size are supported in matrices

    - #### getMatrixIntegerSizeSupported

          com.gs.collections.api.list.ImmutableList<com.io7m.jranges.RangeInclusiveB> getMatrixIntegerSizeSupported()

      Returns:
        The set of supported `integer` sizes in matrices

    - #### isMatrixFloatSizeSupported

          boolean isMatrixFloatSizeSupported(BigInteger size)

      Parameters:
        `size` - The size in bits
      Returns:
        `true` iff `float` types of the given size are supported in matrices

    - #### getMatrixFloatSizeSupported

          com.gs.collections.api.list.ImmutableList<com.io7m.jranges.RangeInclusiveB> getMatrixFloatSizeSupported()

      Returns:
        The set of supported `float` sizes in matrices

    - #### getPackedIntegerSizeBitsSupported

          com.gs.collections.api.list.ImmutableList<com.io7m.jranges.RangeInclusiveB> getPackedIntegerSizeBitsSupported()

      Returns:
        The set of supported `integer` sizes in `packed` types

    - #### isPackedIntegerSizeBitsSupported

          boolean isPackedIntegerSizeBitsSupported(BigInteger size)

      Parameters:
        `size` - The size in bits
      Returns:
        `true` iff `integer` types of the given size are supported in `packed` types

    - #### getPackedSizeBitsSupported

          com.gs.collections.api.list.ImmutableList<com.io7m.jranges.RangeInclusiveB> getPackedSizeBitsSupported()

      Returns:
        The set of supported `packed` type sizes

    - #### isPackedSizeBitsSupported

          boolean isPackedSizeBitsSupported(BigInteger size)

      Parameters:
        `size` - The size in bits
      Returns:
        `true` iff `packed` types of the given size are supported

Copyright © 2016 <code@io7m.com> http://io7m.com